local ADDON_NAME, namespace = ...
local L = namespace.L

BBMenuButtons = 0
if not BuffBuddy_ActiveProfile then
BuffBuddy_ActiveProfile = 1
end
local deleteprofile = ""

function BuffBuddy_CreateOptionsMenu()
CreateFrame("Frame", "BBOptionsFrame", UIParent)
BBOptionsFrame:SetFrameStrata("HIGH")
BBOptionsFrame:SetFrameLevel(4)
BBOptionsFrame:SetPoint("CENTER")
BBOptionsFrame:SetWidth(845)
BBOptionsFrame:SetHeight(670)
BBOptionsFrame:Hide()
CreateFrame("Frame", "$parentBorder", BBOptionsFrame)
BBOptionsFrameBorder:SetWidth(635)
BBOptionsFrameBorder:SetHeight(570)
BBOptionsFrameBorder:SetPoint("RIGHT", BBOptionsFrame, "RIGHT", -15, 10)
BBOptionsFrameBorder:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})
CreateFrame("Frame", "$parentHeaderFrame", BBOptionsFrame)
BBOptionsFrameHeaderFrame:SetHeight(70)
BBOptionsFrameHeaderFrame:SetWidth(350)
BBOptionsFrameHeaderFrame:SetPoint("CENTER", BBOptionsFrame, "TOP", 0, -18)
BBOptionsFrameHeaderFrame:CreateTexture("$parentBackground")
BBOptionsFrameHeaderFrameBackground:SetAllPoints()
BBOptionsFrameHeaderFrameBackground:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
BBOptionsFrameHeaderFrame:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
BBOptionsFrameHeaderFrameText:SetTextColor(1, 0.7, 0)
BBOptionsFrameHeaderFrameText:SetText("Buff Buddy")
BBOptionsFrameHeaderFrameText:SetTextHeight(16)
BBOptionsFrameHeaderFrameText:SetPoint("CENTER", BBOptionsFrameHeaderFrame, "CENTER", 0, 14)
BBOptionsFrame:CreateTexture("$parentBackground")
BBOptionsFrameBackground:SetTexture(0, 0, 0, 0.8)
BBOptionsFrameBackground:SetPoint("CENTER")
BBOptionsFrameBackground:SetWidth(BBOptionsFrame:GetWidth() - 18)
BBOptionsFrameBackground:SetHeight(BBOptionsFrame:GetHeight() - 18)
BBOptionsFrame:SetBackdrop({edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", edgeSize = 25})
CreateFrame("Frame", "$parentButtons", BBOptionsFrame)
BBOptionsFrameButtons:SetWidth(180)
BBOptionsFrameButtons:SetHeight(570)
BBOptionsFrameButtons:SetPoint("LEFT", BBOptionsFrame, "LEFT", 15, 10)
BBOptionsFrameButtons:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})

BBClose = CreateFrame("Button", "BBClose", BBOptionsFrame, "UIPanelCloseButton")
BBClose:ClearAllPoints()
BBClose:SetPoint("TOPRIGHT", BBOptionsFrame, "TOPRIGHT", -5, -5)
BBClose:SetScript("OnClick", function(self)
self:GetParent():Hide()
BuffBuddy_Cancel()
BuffBuddy_OnEvent()
end)

BBApply = CreateFrame("Button", "BBApply", BBOptionsFrame, "UIPanelButtonTemplate")
BBApply:SetHeight(30)
BBApply:SetWidth(80)
BBApply:SetText(APPLY)
BBApply:ClearAllPoints()
BBApply:SetPoint("BOTTOMRIGHT", BBOptionsFrame, "BOTTOMRIGHT", -15, 15)
BBApply:SetScript("OnClick", function(self)
BuffBuddy_Apply()
BuffBuddy_OnEvent()
end)

BBCancel = CreateFrame("Button", "BBCancel", BBOptionsFrame, "UIPanelButtonTemplate")
BBCancel:SetHeight(30)
BBCancel:SetWidth(80)
BBCancel:SetText(CANCEL)
BBCancel:ClearAllPoints()
BBCancel:SetPoint("BOTTOMRIGHT", BBOptionsFrame, "BOTTOMRIGHT", -100, 15)
BBCancel:SetScript("OnClick", function(self)
BuffBuddy_Cancel()
self:GetParent():Hide()
BuffBuddy_OnEvent()
end)

BBOkay = CreateFrame("Button", "BBOkay", BBOptionsFrame, "UIPanelButtonTemplate")
BBOkay:SetHeight(30)
BBOkay:SetWidth(80)
BBOkay:SetText(OKAY)
BBOkay:ClearAllPoints()
BBOkay:SetPoint("BOTTOMRIGHT", BBOptionsFrame, "BOTTOMRIGHT", -185, 15)
BBOkay:SetScript("OnClick", function(self) 
BuffBuddy_Apply()
BuffBuddy_OnEvent()
self:GetParent():Hide()
end)

BBlockframes = CreateFrame("Button", "BBlockframes", BBOptionsFrame, "UIPanelButtonTemplate")
BBlockframes:SetWidth(150)
BBlockframes:SetHeight(30)
BBlockframes:SetPoint("BOTTOMRIGHT", BBOptionsFrame, "BOTTOMRIGHT", -270, 15)
BBlockframes:SetText(L["LOCK_FRAMES"])
BBlockframes:SetScript("OnClick", BuffBuddy_LockFrames)


BBmoveframes = CreateFrame("Button", "BBmoveframes", BBOptionsFrame, "UIPanelButtonTemplate")
BBmoveframes:SetWidth(150)
BBmoveframes:SetHeight(30)
BBmoveframes:SetPoint("BOTTOMRIGHT", BBOptionsFrame, "BOTTOMRIGHT", -425, 15)
BBmoveframes:SetText(L["MOVE_FRAMES"])
BBmoveframes:SetScript("OnClick", BuffBuddy_MoveFrames)

CreateFrame("Frame", "BBReloadUI", UIParent)
BBReloadUI:SetHeight(80)
BBReloadUI:SetWidth(230)
BBReloadUI:SetPoint("CENTER")
BBReloadUI:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
BBReloadUIText:SetPoint("TOP", BBReloadUI, "TOP", 0, -10)
BBReloadUIText:SetText(L["RELOADUI"])
BBReloadUI:CreateTexture("$parentBG")
BBReloadUIBG:SetTexture(0, 0, 0, 0.8)
BBReloadUIBG:SetPoint("CENTER")
BBReloadUIBG:SetWidth(BBReloadUI:GetWidth() - 5)
BBReloadUIBG:SetHeight(BBReloadUI:GetHeight() - 5)
BBReloadUI:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})
CreateFrame("Button", "$parentOkay", BBReloadUI, "UIPanelButtonTemplate")
BBReloadUIOkay:ClearAllPoints()
BBReloadUIOkay:SetWidth(60)
BBReloadUIOkay:SetHeight(30)
BBReloadUIOkay:SetPoint("BOTTOM", BBReloadUI, "BOTTOM", -37, 5)
BBReloadUIOkay:SetText(OKAY)
BBReloadUIOkay:SetScript("OnClick", function()
ReloadUI()
BBReloadUI:Hide()
end)
CreateFrame("Button", "$parentCancel", BBReloadUI, "UIPanelButtonTemplate")
BBReloadUICancel:ClearAllPoints()
BBReloadUICancel:SetWidth(60)
BBReloadUICancel:SetHeight(30)
BBReloadUICancel:SetPoint("BOTTOM", BBReloadUI, "BOTTOM", 37, 5)
BBReloadUICancel:SetText(CANCEL)
BBReloadUICancel:SetScript("OnClick", function()
BBReloadUI:Hide()
end)
BBReloadUI:SetFrameStrata("HIGH")
BBReloadUI:SetFrameLevel(3)
BBReloadUI:Hide()

CreateFrame("Frame", "BBDefaultsWarning", BBOptionsFrame)
BBDefaultsWarning:SetHeight(100)
BBDefaultsWarning:SetWidth(230)
BBDefaultsWarning:SetPoint("CENTER")
BBDefaultsWarning:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
BBDefaultsWarningText:SetPoint("TOP", BBDefaultsWarning, "TOP", 0, -10)
BBDefaultsWarningText:SetText(L["DEFAULTS_WARNING"])
BBDefaultsWarning:CreateTexture("$parentBG")
BBDefaultsWarningBG:SetTexture(0, 0, 0, 0.8)
BBDefaultsWarningBG:SetPoint("CENTER")
BBDefaultsWarningBG:SetWidth(BBDefaultsWarning:GetWidth() - 5)
BBDefaultsWarningBG:SetHeight(BBDefaultsWarning:GetHeight() - 5)
BBDefaultsWarning:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})
CreateFrame("Button", "$parentOkay", BBDefaultsWarning, "UIPanelButtonTemplate")
BBDefaultsWarningOkay:ClearAllPoints()
BBDefaultsWarningOkay:SetWidth(60)
BBDefaultsWarningOkay:SetHeight(30)
BBDefaultsWarningOkay:SetPoint("BOTTOM", BBDefaultsWarning, "BOTTOM", -37, 5)
BBDefaultsWarningOkay:SetText(OKAY)
BBDefaultsWarningOkay:SetScript("OnClick", function()
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options = nil
BuffBuddy_Check()
BuffBuddy_Cancel()
BuffBuddy_PlaceFrames()
BuffBuddy_UpdateUI()
BBDefaultsWarning:Hide()
end)
CreateFrame("Button", "$parentCancel", BBDefaultsWarning, "UIPanelButtonTemplate")
BBDefaultsWarningCancel:ClearAllPoints()
BBDefaultsWarningCancel:SetWidth(60)
BBDefaultsWarningCancel:SetHeight(30)
BBDefaultsWarningCancel:SetPoint("BOTTOM", BBDefaultsWarning, "BOTTOM", 37, 5)
BBDefaultsWarningCancel:SetText(CANCEL)
BBDefaultsWarningCancel:SetScript("OnClick", function()
BBDefaultsWarning:Hide()
end)
BBDefaultsWarning:SetFrameStrata("HIGH")
BBDefaultsWarning:Hide()
BBDefaultsWarning:SetFrameLevel(4)
BBDefaults = CreateFrame("Button", "BBDefaults", BBOptionsFrame, "UIPanelButtonTemplate")
BBDefaults:SetHeight(30)
BBDefaults:SetWidth(80)
BBDefaults:SetText(DEFAULTS)
BBDefaults:ClearAllPoints()
BBDefaults:SetPoint("BOTTOMLEFT", BBOptionsFrame, "BOTTOMLEFT", 15, 15)
BBDefaults:SetScript("OnClick", function()
BBDefaultsWarning:Show()
end)


CreateFrame("Frame", "BBDeleteWarning", BBOptionsFrame)
BBDeleteWarning:SetHeight(120)
BBDeleteWarning:SetWidth(230)
BBDeleteWarning:SetPoint("CENTER")
BBDeleteWarning:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
BBDeleteWarningText:SetPoint("TOP", BBDeleteWarning, "TOP", 0, -10)
BBDeleteWarning:CreateTexture("$parentBG")
BBDeleteWarningBG:SetTexture(0, 0, 0, 0.8)
BBDeleteWarningBG:SetPoint("CENTER")
BBDeleteWarningBG:SetWidth(BBDeleteWarning:GetWidth() - 5)
BBDeleteWarningBG:SetHeight(BBDeleteWarning:GetHeight() - 5)
BBDeleteWarning:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})
CreateFrame("Button", "$parentOkay", BBDeleteWarning, "UIPanelButtonTemplate")
BBDeleteWarningOkay:ClearAllPoints()
BBDeleteWarningOkay:SetWidth(60)
BBDeleteWarningOkay:SetHeight(30)
BBDeleteWarningOkay:SetPoint("BOTTOM", BBDeleteWarning, "BOTTOM", -37, 5)
BBDeleteWarningOkay:SetText(OKAY)
BBDeleteWarningOkay:SetScript("OnClick", function()
for idx = 1, #BuffBuddy_Profiles do
if BuffBuddy_Profiles[idx].name == deleteprofile then
print("|cFF00DFFF"..L["PROFILE_DELETED"]..BuffBuddy_Profiles[idx].name.."|r")
_G["BBProfileFrameContentButton"..#BuffBuddy_Profiles]:Hide()
_G["BBProfileFrameContentButton"..idx].clicked = false
if BuffBuddy_ActiveProfile == idx then
if BuffBuddy_ActiveProfile == 1 and #BuffBuddy_Profiles == 1 then
table.insert(BuffBuddy_Profiles, {name = UnitName("player"), active = true})
BuffBuddy_Check(nil, 2)
BuffBuddy_ActiveProfile = 2
table.remove(BuffBuddy_Profiles, idx)
BuffBuddy_ActiveProfile = 1
else
BuffBuddy_ActiveProfile = 1
table.remove(BuffBuddy_Profiles, idx)
end
else
if BuffBuddy_ActiveProfile > idx then
BuffBuddy_ActiveProfile = BuffBuddy_ActiveProfile - 1
end
table.remove(BuffBuddy_Profiles, idx)
end

if BuffBuddy_Profiles[BuffBuddy_ActiveProfile].active ~= true then
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].active = true
BuffBuddy_UpdateProfile()
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile].clicked = true
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:Show()
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Text"]:SetTextColor(1, 1, 1)
deleteprofile = ""
BBDeleteWarning:Hide()
return
else
BuffBuddy_UpdateProfile()
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile].clicked = true
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:Show()
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Text"]:SetTextColor(1, 1, 1)
deleteprofile = ""
BBDeleteWarning:Hide()
return
end
end
end
print("|cFF00DFFF"..L["PROFILE_NOT_FOUND"]..deleteprofile.."|r")
deleteprofile = ""
BBDeleteWarning:Hide()
end)
CreateFrame("Button", "$parentCancel", BBDeleteWarning, "UIPanelButtonTemplate")
BBDeleteWarningCancel:ClearAllPoints()
BBDeleteWarningCancel:SetWidth(60)
BBDeleteWarningCancel:SetHeight(30)
BBDeleteWarningCancel:SetPoint("BOTTOM", BBDeleteWarning, "BOTTOM", 37, 5)
BBDeleteWarningCancel:SetText(CANCEL)
BBDeleteWarningCancel:SetScript("OnClick", function()
BBDeleteWarning:Hide()
end)
BBDeleteWarning:SetFrameStrata("HIGH")
BBDeleteWarning:Hide()
BBDeleteWarning:SetFrameLevel(4)



local x, y, xoff, yoff = 0, 0, 15, -20
BuffBuddy = {}
BuffBuddy.panel = CreateFrame("Frame", "BBOptions", BBOptionsFrame)
BuffBuddy.panel:SetWidth(625)
BuffBuddy.panel:SetHeight(570)
BuffBuddy.panel:SetPoint("LEFT", BBOptionsFrameButtons, "RIGHT", 5, 20)
BuffBuddy.panel.name = "Buff Buddy"

BuffBuddy.panel:Hide()

----------------------------------------------------------------------
y = 0
y = y + yoff * 2
BBHideFrames = CreateFrame("CheckButton", "BBHideFrames", BuffBuddy.panel, "ChatConfigCheckButtonTemplate")
BBHideFrames:SetPoint("TOPLEFT", 15, y)
BBHideFramesText:SetText(L["HIDE_FRAMES"])
BBHideFrames:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.hideframes)
-----------------------------------------------------------------------
y = -40
BuffBuddy.panel:CreateFontString("BBProfileHeader", "OVERLAY", "GameFontNormal")
BBProfileHeader:SetPoint("TOP", 175, y)
BBProfileHeader:SetTextHeight(16)
BBProfileHeader:SetText(L["PROFILE"]..BuffBuddy_Profiles[BuffBuddy_ActiveProfile].name)
-----------------------------------------------------------------------
y = y + yoff * 1.5
CreateFrame("Frame", "BBProfileFrame", BuffBuddy.panel)
BBProfileFrame:SetPoint("TOP", 180, y)
BBProfileFrame:SetWidth(200)
BBProfileFrame:SetHeight(300)
BBProfileFrame:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})


BBProfileFrameScrollFrame = CreateFrame("ScrollFrame", "BBProfileFrameScrollFrame", BBProfileFrame)
BBProfileFrameScrollFrame:SetPoint("TOPLEFT", 10, -10) 
BBProfileFrameScrollFrame:SetPoint("BOTTOMRIGHT", -30, 40) 

BBProfileFrameContent = CreateFrame("Frame", "BBProfileFrameContent", BBProfileFrameScrollFrame)
BBProfileFrameContent:SetPoint("CENTER")
BBProfileFrameContent:SetWidth(160)
BBProfileFrameContent:SetHeight(#BuffBuddy_Profiles * 20 + 300)
BBProfileFrameScrollFrame:SetScrollChild(BBProfileFrameContent)

BBProfileFrameScroll = CreateFrame("Slider", "BBProfileFrameScroll", BBProfileFrameScrollFrame, "UIPanelScrollBarTemplate")
BBProfileFrameScroll:CreateTexture("$parentBG")
BBProfileFrameScrollBG:SetWidth(16)
BBProfileFrameScrollBG:SetHeight(245)
BBProfileFrameScrollBG:SetPoint("CENTER", -0.5, 0)
BBProfileFrameScrollBG:SetTexture(0.2, 0.2, 0.2, 0.5)
BBProfileFrameScroll:SetOrientation("VERTICAL")
BBProfileFrameScroll:SetWidth(20)
BBProfileFrameScroll:SetHeight(250)
BBProfileFrameScroll:SetPoint("RIGHT", BBProfileFrame, "RIGHT", -5, 0)
BBProfileFrameScroll:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
BBProfileFrameScroll:SetValueStep(20)
BBProfileFrameScroll:SetValue(0)
BBProfileFrameContent:SetScript("OnMouseWheel", function(self, delta)
local scroll = BBProfileFrameScroll:GetValue()
if delta > 0  then
BBProfileFrameScroll:SetValue(scroll - BBProfileFrameScroll:GetValueStep())
elseif delta < 0 then
BBProfileFrameScroll:SetValue(scroll + BBProfileFrameScroll:GetValueStep())
end
end)
BBProfileFrameScroll:SetMinMaxValues(0, (#BuffBuddy_Profiles * 20))
BBProfileFrameScroll:SetValue(0)
----------------------------------------------------------------------------------
y = y + yoff * 2 - 270
BBProfileInput = CreateFrame("EditBox", "BBProfileInput", BuffBuddy.panel, "InputBoxTemplate")
BBProfileInput:SetPoint("TOP", 185, y)
BBProfileInput:SetWidth(200)
BBProfileInput:SetHeight(20)
BBProfileInput:SetAutoFocus(false)
-----------------------------------------------------------------------
-----------------------------------------------------------------------
y = y + yoff * 2 + 10

BBNew = CreateFrame("Button", "BBNew", BuffBuddy.panel, "UIPanelButtonTemplate")
BBNew:SetHeight(30)
BBNew:SetWidth(80)
BBNew:SetText(NEW)
BBNew:ClearAllPoints()
BBNew:SetPoint("TOP", 95, y)
BBNew:SetScript("OnClick", function(self) 

for idx = 1, #BuffBuddy_Profiles do
if BuffBuddy_Profiles[idx].name == BBProfileInput:GetText() then
BBProfileInput:SetText("")
print("|cFF00DFFF"..L["PROFILE_ALREADY_EXISTS"].."|r")
return
elseif BBProfileInput:GetText() == "" then
print("|cFF00DFFF"..L["BAD_PROFILE_NAME"].."|r")
return
end
end

BuffBuddy_Profiles[BuffBuddy_ActiveProfile].active = false
table.insert(BuffBuddy_Profiles, {name = BBProfileInput:GetText(), active = true})
BuffBuddy_Check(nil, #BuffBuddy_Profiles)
BuffBuddy_ActiveProfile = #BuffBuddy_Profiles
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].active = true
print("|cFF00DFFF"..L["PROFILE_CREATED"]..BBProfileInput:GetText().."|r")
BuffBuddy_UpdateProfile()
BBProfileInput:SetText("")
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile].clicked = true
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:Show()
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Text"]:SetTextColor(1, 1, 1)
BuffBuddy_Cancel()
end)

BBLoad = CreateFrame("Button", "BBLoad", BuffBuddy.panel, "UIPanelButtonTemplate")
BBLoad:SetHeight(30)
BBLoad:SetWidth(80)
BBLoad:SetText(L["LOAD"])
BBLoad:ClearAllPoints()
BBLoad:SetPoint("TOP", 180, y)
BBLoad:SetScript("OnClick", function(self)

BuffBuddy_Profiles[BuffBuddy_ActiveProfile].active = false
for idx = 1, #BuffBuddy_Profiles do 
if BuffBuddy_Profiles[idx].name == BBProfileInput:GetText() then
BuffBuddy_Profiles[idx].active = true
BuffBuddy_UpdateProfile()
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile].clicked = true
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:Show()
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G["BBProfileFrameContentButton"..BuffBuddy_ActiveProfile.."Text"]:SetTextColor(1, 1, 1)
return
end
end
print("|cFF00DFFF"..L["PROFILE_NOT_FOUND"]..BBProfileInput:GetText().."|r")
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].active = true
end)

BBDelete = CreateFrame("Button", "BBDelete", BuffBuddy.panel, "UIPanelButtonTemplate")
BBDelete:SetHeight(30)
BBDelete:SetWidth(80)
BBDelete:SetText(DELETE)
BBDelete:ClearAllPoints()
BBDelete:SetPoint("TOP", 265, y)
BBDelete:SetScript("OnClick", function(self) 
BBDeleteWarningText:SetText(L["DELETE_WARNING"]..BBProfileInput:GetText())
BBDeleteWarning:Show()
deleteprofile = BBProfileInput:GetText()
BBProfileInput:SetText("")
end)

function BuffBuddy_SortByIndex(a, b)
return a.index < b.index
end

end



SLASH_BUFFBUDDY1 = "/bb"
SLASH_BUFFBUDDY2 = "/buffbuddy"
SlashCmdList["BUFFBUDDY"] = function()
for idx = 1, BBMenuButtons do
local frame = _G["BBOptionsFrameButtonsButton"..idx]
frame.clicked = false
_G["BBOptionsFrameButtonsButton"..idx.."Highlight"]:Hide()
_G["BBOptionsFrameButtonsButton"..idx.."Text"]:SetTextColor(1, 0.83, 0)
frame.parent:Hide()
end
BBOptionsFrameButtonsButton1.clicked = true
BBOptionsFrameButtonsButton1Highlight:Show()
BBOptionsFrameButtonsButton1Highlight:SetTexture(1, 1, 0, 0.6)
BBOptionsFrameButtonsButton1Text:SetTextColor(1, 1, 1)
BuffBuddy.panel:Show()
BBOptionsFrame:Show()
end

function BuffBuddy_FinishOptionsMenu()
for frame in pairs(BuffBuddy) do
BBMenuButtons = BBMenuButtons + 1
end

local buttoncount = 0

for frame, BBMenuButtons in pairs(BuffBuddy) do
local button = CreateFrame("Button", "$parentButton"..buttoncount + 1, BBOptionsFrameButtons)
button.parent = BuffBuddy[frame]
button.clicked = false
button:SetWidth(160)
button:SetHeight(20)
if button == BBOptionsFrameButtonsButton1 then
button:SetPoint("TOPLEFT", 10, -10)
else
button:SetPoint("TOP", _G["BBOptionsFrameButtonsButton"..buttoncount], "BOTTOM")
end
button:SetScript("OnEnter", BuffBuddy_MenuOnEnter)
button:SetScript("OnLeave", BuffBuddy_MenuOnLeave)
button:SetScript("OnClick", BuffBuddy_MenuOnClick)
text = button:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
text:SetPoint("LEFT")
text:SetJustifyH("LEFT")
text:SetTextColor(1, 0.83, 0)
text:SetText(BuffBuddy[frame].name)
highlight = button:CreateTexture("$parentHighlight")
highlight:SetAllPoints()
highlight:Hide()
buttoncount = buttoncount + 1
end
BBProfileFrame:SetFrameLevel(5)
BBReloadUI:SetFrameLevel(6)
BBDeleteWarning:SetFrameLevel(6)
BBDefaultsWarning:SetFrameLevel(7)
end


function BuffBuddy_Cancel()
BBHideFrames:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.hideframes)

BBBuffFrame:SetScale(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbbuffframe)
BBDebuffFrame:SetScale(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbdebuffframe)

BBBuffFrameScale:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbbuffframe)
BBDebuffFrameScale:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbdebuffframe)
BBBuffPerRow:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffperrow)
BBBuffVerticalSpacing:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffverticalspacing)
BBBuffHorizontalSpacing:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffhorizontalspacing)
BBDebuffPerRow:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffperrow)
BBDebuffVerticalSpacing:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffverticalspacing)
BBDebuffHorizontalSpacing:SetValue(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffhorizontalspacing)

BBBuffNewRowUp:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffnewrowup)
BBBuffLeftToRight:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.bufflefttoright)
BBDebuffNewRowUp:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffnewrowup)
BBDebuffLeftToRight:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debufflefttoright)

BuffBuddy_UpdateUI()
end

function BuffBuddy_Apply()
BBProfileHeader:SetText(L["PROFILE"]..BuffBuddy_Profiles[BuffBuddy_ActiveProfile].name)

BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.hideframes = BuffBuddy_Convert(BBHideFrames:GetChecked())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbbuffframe = BuffBuddy_Round(BBBuffFrameScale:GetValue())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbdebuffframe = BuffBuddy_Round(BBDebuffFrameScale:GetValue())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffperrow = BuffBuddy_Round(BBBuffPerRow:GetValue())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffverticalspacing = BuffBuddy_Round(BBBuffVerticalSpacing:GetValue())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffhorizontalspacing = BuffBuddy_Round(BBBuffHorizontalSpacing:GetValue())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffperrow = BuffBuddy_Round(BBDebuffPerRow:GetValue())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffverticalspacing = BuffBuddy_Round(BBDebuffVerticalSpacing:GetValue())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffhorizontalspacing = BuffBuddy_Round(BBDebuffHorizontalSpacing:GetValue())

BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.bufflefttoright = BuffBuddy_Convert(BBBuffLeftToRight:GetChecked())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffnewrowup = BuffBuddy_Convert(BBBuffNewRowUp:GetChecked())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debufflefttoright = BuffBuddy_Convert(BBDebuffLeftToRight:GetChecked())
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffnewrowup = BuffBuddy_Convert(BBDebuffNewRowUp:GetChecked())

BuffBuddy_UpdateUI()
print("|cFF00DFFF"..L["PROFILE_SAVED"]..BuffBuddy_Profiles[BuffBuddy_ActiveProfile].name.."|r")
end

-- turns the nil value(unchecked box) into a number for storing in options table for later use
function BuffBuddy_Convert(arg)
return arg
end


function BuffBuddy_Check(loading, alt)
if not BuffBuddy_ActiveProfile then 
BuffBuddy_ActiveProfile = 1
end
local index = BuffBuddy_ActiveProfile
if alt then index = alt end
if not BuffBuddy_Profiles then
BuffBuddy_Profiles = {{name = UnitName("player"), active = true}}
index = 1
BuffBuddy_ActiveProfile = 1
end
if not BuffBuddy_Profiles[index].options then
BuffBuddy_Profiles[index].options = {
hideframes = false,
buffhorizontalspacing = 5,
buffverticalspacing = 15,
debuffhorizontalspacing = 5,
debuffverticalspacing = 15,
bufflefttoright = false,
debufflefttoright = false,
buffnewrowup = false,
debuffnewrowup = false,
buffperrow = 8,
debuffperrow = 8,

scale = {
bbbuffframe = 1,
bbdebuffframe = 1,
},


buffprioritylist = {}, 
debuffprioritylist = {},

BBBuffFrameDrag = {"TOPRIGHT", nil, "TOPRIGHT", -170, -50},
BBDebuffFrameDrag = {"RIGHT", nil, "RIGHT", -170, 126},
}
end
end


function BuffBuddy_MenuOnEnter(self)
local buttons = BBMenuButtons
if self:GetParent() == BBProfileFrameContent then
buttons = #BuffBuddy_Profiles
end
if self:GetParent() == BBBuffPriorityListFrameContent then
buttons = #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist
end
if self:GetParent() == BBDebuffPriorityListFrameContent then
buttons = #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist
end
for idx = 1, buttons do
local frame = _G[self:GetParent():GetName().."Button"..idx]
if frame.clicked ~= true then
_G[self:GetParent():GetName().."Button"..idx.."Highlight"]:Hide()
end
end
_G[self:GetName().."Highlight"]:Show()
if self.clicked ~= true then
_G[self:GetName().."Highlight"]:SetTexture(0, 0.7, 1, 0.6)
else
_G[self:GetName().."Highlight"]:SetTexture(1, 1, 0, 0.6)
end
end

function BuffBuddy_MenuOnLeave(self)
local buttons = BBMenuButtons
if self:GetParent() == BBProfileFrameContent then
buttons = #BuffBuddy_Profiles
end
if self:GetParent() == BBBuffPriorityListFrameContent then
buttons = #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist
end
if self:GetParent() == BBDebuffPriorityListFrameContent then
buttons = #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist
end
for idx = 1, buttons do
local frame = _G[self:GetParent():GetName().."Button"..idx]
if frame.clicked ~= true then
_G[self:GetParent():GetName().."Button"..idx.."Highlight"]:Hide()
end
end
end

function BuffBuddy_MenuOnClick(self)
local buttons = BBMenuButtons
if self:GetParent() == BBProfileFrameContent then
buttons = #BuffBuddy_Profiles
elseif self:GetParent() == BBBuffPriorityListFrameContent then
buttons = #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist
elseif self:GetParent() == BBDebuffPriorityListFrameContent then
buttons = #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist
end
for idx = 1, buttons do
local frame = _G[self:GetParent():GetName().."Button"..idx]
frame.clicked = false
_G[self:GetParent():GetName().."Button"..idx.."Highlight"]:Hide()
_G[self:GetParent():GetName().."Button"..idx.."Text"]:SetTextColor(1, 0.83, 0)
if self:GetParent() ~= BBProfileFrameContent and self:GetParent() ~= BBBuffPriorityListFrameContent and self:GetParent() ~= BBDebuffPriorityListFrameContent then
frame.parent:Hide()
elseif self:GetParent() == BBProfileFrameContent then
BBProfileInput:SetText(_G[self:GetName().."Text"]:GetText())
elseif self:GetParent() == BBBuffPriorityListFrameContent then
BBBuffInput:SetText(GetSpellInfo(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist[_G[self:GetName()].index].spellid))
elseif self:GetParent() == BBDebuffPriorityListFrameContent then
BBDebuffInput:SetText(GetSpellInfo(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist[_G[self:GetName()].index].spellid))
end
end
self.clicked = true
_G[self:GetName().."Highlight"]:Show()
_G[self:GetName().."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G[self:GetName().."Text"]:SetTextColor(1, 1, 1)
if self:GetParent() ~= BBProfileFrameContent and self:GetParent() ~= BBBuffPriorityListFrameContent and self:GetParent() ~= BBDebuffPriorityListFrameContent then
self.parent:Show()
end
end



function BuffBuddy_UpdateProfile()

for idx = 1, #BuffBuddy_Profiles do

if not _G["BBProfileFrameContentButton"..idx] then
local button = CreateFrame("Button", "$parentButton"..idx, BBProfileFrameContent)
button.clicked = false
button:SetWidth(120)
button:SetHeight(20)
if button == BBProfileFrameContentButton1 then
button:SetPoint("TOP", BBProfileFrameContent, "TOP")
else
button:SetPoint("TOP", _G[BBProfileFrameContent:GetName().."Button"..idx - 1], "BOTTOM")
end
button:SetScript("OnEnter", BuffBuddy_MenuOnEnter)
button:SetScript("OnLeave", BuffBuddy_MenuOnLeave)
button:SetScript("OnClick", BuffBuddy_MenuOnClick)
text = button:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
text:SetPoint("CENTER")
text:SetTextColor(1, 0.83, 0)
highlight = button:CreateTexture("$parentHighlight")
highlight:SetAllPoints()
highlight:Hide()
_G["BBProfileFrameContentButton"..idx]:Show()
else
button = _G["BBProfileFrameContentButton"..idx]
text = _G["BBProfileFrameContentButton"..idx.."Text"]
highlight = _G["BBProfileFrameContentButton"..idx.."Highlight"]
button.clicked = false
if button == BBProfileFrameContentButton1 then
button:ClearAllPoints()
button:SetPoint("TOP", BBProfileFrameContent, "TOP")
else
button:ClearAllPoints()
button:SetPoint("TOP", _G[BBProfileFrameContent:GetName().."Button"..idx - 1], "BOTTOM")
end
text:SetTextColor(1, 0.83, 0)
text:SetText(BuffBuddy_Profiles[idx].name)
highlight:Hide()
end
_G[BBProfileFrameContent:GetName().."Button"..idx.."Text"]:SetText(BuffBuddy_Profiles[idx].name)
_G[BBProfileFrameContent:GetName().."Button"..idx]:Show()
end


for idx = 1, #BuffBuddy_Profiles do
if BuffBuddy_Profiles[idx].active == true then
print("|cFF00DFFF"..L["PROFILE_LOADED"]..BuffBuddy_Profiles[idx].name.."|r")
BuffBuddy_ActiveProfile = idx
BBProfileInput:SetText("")
BuffBuddy_PlaceFrames()
BuffBuddy_Cancel()
break
end
end

end

function BuffBuddy_UpdateDebuffPriority()
tbl = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist
if #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist > 0 then
for idx = 1, #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist do

if not _G["BBDebuffPriorityListFrameContentButton"..idx] then
local button = CreateFrame("Button", "$parentButton"..idx, BBDebuffPriorityListFrameContent)
button.clicked = false
button:SetWidth(120)
button:SetHeight(20)
if button == BBDebuffPriorityListFrameContentButton1 then
button:SetPoint("TOPLEFT", BBDebuffPriorityListFrameContent, "TOPLEFT")
else
button:SetPoint("TOPLEFT", _G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx - 1], "BOTTOMLEFT")
end
button:SetScript("OnEnter", BuffBuddy_MenuOnEnter)
button:SetScript("OnLeave", BuffBuddy_MenuOnLeave)
button:SetScript("OnClick", BuffBuddy_MenuOnClick)
text = button:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
text:SetPoint("LEFT")
text:SetTextColor(1, 0.83, 0)
text:SetJustifyH("LEFT")
highlight = button:CreateTexture("$parentHighlight")
highlight:SetAllPoints()
highlight:Hide()
_G["BBDebuffPriorityListFrameContentButton"..idx]:Show()
else
button = _G["BBDebuffPriorityListFrameContentButton"..idx]
text = _G["BBDebuffPriorityListFrameContentButton"..idx.."Text"]
highlight = _G["BBDebuffPriorityListFrameContentButton"..idx.."Highlight"]
button.clicked = false
if button == BBDebuffPriorityListFrameContentButton1 then
button:ClearAllPoints()
button:SetPoint("TOPLEFT", BBDebuffPriorityListFrameContent, "TOPLEFT")
else
button:ClearAllPoints()
button:SetPoint("TOPLEFT", _G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx - 1], "BOTTOMLEFT")
end
text:SetTextColor(1, 0.83, 0)
text:SetText(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist[idx].index..") "..GetSpellInfo(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist[idx].spellid))
_G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx].index = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist[idx].index
highlight:Hide()
end
_G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx].index = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist[idx].index
_G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx.."Text"]:SetText(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist[idx].index..") "..GetSpellInfo(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist[idx].spellid))
_G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx]:Show()
end


end

local loop, idx = true, #tbl
while loop == true do
idx = idx + 1
if _G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx] then
_G[BBDebuffPriorityListFrameContent:GetName().."Button"..idx]:Hide()
else
loop = false
end
end
end

function BuffBuddy_UpdateBuffPriority()
tbl = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist
if #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist > 0 then
for idx = 1, #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist do

if not _G["BBBuffPriorityListFrameContentButton"..idx] then
local button = CreateFrame("Button", "$parentButton"..idx, BBBuffPriorityListFrameContent)
button.clicked = false
button:SetWidth(120)
button:SetHeight(20)
if button == BBBuffPriorityListFrameContentButton1 then
button:SetPoint("TOPLEFT", BBBuffPriorityListFrameContent, "TOPLEFT")
else
button:SetPoint("TOPLEFT", _G[BBBuffPriorityListFrameContent:GetName().."Button"..idx - 1], "BOTTOMLEFT")
end
button:SetScript("OnEnter", BuffBuddy_MenuOnEnter)
button:SetScript("OnLeave", BuffBuddy_MenuOnLeave)
button:SetScript("OnClick", BuffBuddy_MenuOnClick)
text = button:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
text:SetPoint("LEFT")
text:SetTextColor(1, 0.83, 0)
text:SetJustifyH("LEFT")
highlight = button:CreateTexture("$parentHighlight")
highlight:SetAllPoints()
highlight:Hide()
_G["BBBuffPriorityListFrameContentButton"..idx]:Show()
else
button = _G["BBBuffPriorityListFrameContentButton"..idx]
text = _G["BBBuffPriorityListFrameContentButton"..idx.."Text"]
highlight = _G["BBBuffPriorityListFrameContentButton"..idx.."Highlight"]
button.clicked = false
if button == BBBuffPriorityListFrameContentButton1 then
button:ClearAllPoints()
button:SetPoint("TOPLEFT", BBBuffPriorityListFrameContent, "TOPLEFT")
else
button:ClearAllPoints()
button:SetPoint("TOPLEFT", _G[BBBuffPriorityListFrameContent:GetName().."Button"..idx - 1], "BOTTOMLEFT")
end
text:SetTextColor(1, 0.83, 0)
text:SetText(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist[idx].index..") "..GetSpellInfo(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist[idx].spellid))
_G[BBBuffPriorityListFrameContent:GetName().."Button"..idx].index = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist[idx].index
highlight:Hide()
end
_G[BBBuffPriorityListFrameContent:GetName().."Button"..idx].index = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist[idx].index
_G[BBBuffPriorityListFrameContent:GetName().."Button"..idx.."Text"]:SetText(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist[idx].index..") "..GetSpellInfo(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist[idx].spellid))
_G[BBBuffPriorityListFrameContent:GetName().."Button"..idx]:Show()
end


end

local loop, idx = true, #tbl
while loop == true do
idx = idx + 1
if _G[BBBuffPriorityListFrameContent:GetName().."Button"..idx] then
_G[BBBuffPriorityListFrameContent:GetName().."Button"..idx]:Hide()
else
loop = false
end
end
end


function BuffBuddy_CreateBuffsOptionsMenu()
-- Buffs Options --------------------------------------------------
BuffBuddy.buffs = CreateFrame("Frame", "BBBuffsOptions", BBOptionsFrame)
BuffBuddy.buffs:SetWidth(625)
BuffBuddy.buffs:SetHeight(570)
BuffBuddy.buffs:SetPoint("LEFT", BBOptionsFrameButtons, "RIGHT", 5, 0)
BuffBuddy.buffs.name = L["BUFFS"]

BBBuffsScrollFrame = CreateFrame("ScrollFrame", "BBBuffsScrollFrame", BuffBuddy.buffs)
BBBuffsScrollFrame:SetPoint("TOPLEFT", 10, -10) 
BBBuffsScrollFrame:SetPoint("BOTTOMRIGHT", -15, 15) 

BBBuffsContent = CreateFrame("Frame", "BBBuffsContent", BBBuffsScrollFrame)
BBBuffsContent:SetPoint("CENTER")
BBBuffsContent:SetWidth(580)
BBBuffsContent:SetHeight(2000)
BBBuffsScrollFrame:SetScrollChild(BBBuffsContent)

BBBuffsScroll = CreateFrame("Slider", "BBBuffsScroll", BBBuffsScrollFrame, "UIPanelScrollBarTemplate")
BBBuffsScroll:CreateTexture("$parentBG")
BBBuffsScrollBG:SetWidth(16)
BBBuffsScrollBG:SetHeight(445)
BBBuffsScrollBG:SetPoint("CENTER", -0.5, 0)
BBBuffsScrollBG:SetTexture(0.2, 0.2, 0.2, 0.5)
BBBuffsScroll:SetOrientation("VERTICAL")
BBBuffsScroll:SetWidth(20)
BBBuffsScroll:SetHeight(450)
BBBuffsScroll:SetPoint("RIGHT", BuffBuddy.buffs, "RIGHT", -5, 0)
BBBuffsScroll:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
BBBuffsScroll:SetValueStep(20)
BBBuffsScroll:SetValue(0)
BBBuffsContent:SetScript("OnMouseWheel", function(self, delta)
local scroll = BBBuffsScroll:GetValue()
if delta > 0  then
BBBuffsScroll:SetValue(scroll - BBBuffsScroll:GetValueStep())
elseif delta < 0 then
BBBuffsScroll:SetValue(scroll + BBBuffsScroll:GetValueStep())
end
end)
-------------------------------------------------------------------------
local x, y, xoff, yoff = 0, 0, 15, -20
CreateFrame("Frame", "BBBuffPriorityListFrame", BBBuffsContent)
BBBuffPriorityListFrame:SetPoint("TOP", -20, -50)
BBBuffPriorityListFrame:SetWidth(200)
BBBuffPriorityListFrame:SetHeight(300)
BBBuffPriorityListFrame:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})

BBBuffPriorityListFrame:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
BBBuffPriorityListFrameText:SetPoint("BOTTOM", BBBuffPriorityListFrame, "TOP", 0, 10)
BBBuffPriorityListFrameText:SetTextHeight(20)
BBBuffPriorityListFrameText:SetText(L["BUFF_PRIORITY_LIST"])


BBBuffPriorityListFrameScrollFrame = CreateFrame("ScrollFrame", "BBBuffPriorityListFrameScrollFrame", BBBuffPriorityListFrame)
BBBuffPriorityListFrameScrollFrame:SetPoint("TOPLEFT", 10, -10) 
BBBuffPriorityListFrameScrollFrame:SetPoint("BOTTOMRIGHT", -30, 40) 

BBBuffPriorityListFrameContent = CreateFrame("Frame", "BBBuffPriorityListFrameContent", BBBuffPriorityListFrameScrollFrame)
BBBuffPriorityListFrameContent:SetPoint("CENTER")
BBBuffPriorityListFrameContent:SetWidth(160)
BBBuffPriorityListFrameContent:SetHeight(#BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist * 20 + 300)
BBBuffPriorityListFrameScrollFrame:SetScrollChild(BBBuffPriorityListFrameContent)

BBBuffPriorityListFrameScroll = CreateFrame("Slider", "BBBuffPriorityListFrameScroll", BBBuffPriorityListFrameScrollFrame, "UIPanelScrollBarTemplate")
BBBuffPriorityListFrameScroll:CreateTexture("$parentBG")
BBBuffPriorityListFrameScrollBG:SetWidth(16)
BBBuffPriorityListFrameScrollBG:SetHeight(245)
BBBuffPriorityListFrameScrollBG:SetPoint("CENTER", -0.5, 0)
BBBuffPriorityListFrameScrollBG:SetTexture(0.2, 0.2, 0.2, 0.5)
BBBuffPriorityListFrameScroll:SetOrientation("VERTICAL")
BBBuffPriorityListFrameScroll:SetWidth(20)
BBBuffPriorityListFrameScroll:SetHeight(250)
BBBuffPriorityListFrameScroll:SetPoint("RIGHT", BBBuffPriorityListFrame, "RIGHT", -5, 0)
BBBuffPriorityListFrameScroll:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
BBBuffPriorityListFrameScroll:SetValueStep(20)
BBBuffPriorityListFrameScroll:SetValue(0)
BBBuffPriorityListFrameContent:SetScript("OnMouseWheel", function(self, delta)
local scroll = BBBuffPriorityListFrameScroll:GetValue()
if delta > 0  then
BBBuffPriorityListFrameScroll:SetValue(scroll - BBBuffPriorityListFrameScroll:GetValueStep())
elseif delta < 0 then
BBBuffPriorityListFrameScroll:SetValue(scroll + BBBuffPriorityListFrameScroll:GetValueStep())
end
end)
BBBuffPriorityListFrameScroll:SetMinMaxValues(0, (#BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist * 20))
BBBuffPriorityListFrameScroll:SetValue(0)
----------------------------------------------------------------------------------
y = y + yoff * 2 - 270
BBBuffInput = CreateFrame("EditBox", "BBBuffInput", BBBuffsContent, "InputBoxTemplate")
BBBuffInput:SetPoint("TOP", -20, y - 60)
BBBuffInput:SetWidth(200)
BBBuffInput:SetHeight(20)
BBBuffInput:SetAutoFocus(false)
BBBuffInput:SetScript("OnEnterPressed", function(self)
BBBuffsNew:Click()
end)
-----------------------------------------------------------------------
-----------------------------------------------------------------------
y = y + yoff * 2 + 10

BBBuffsNew = CreateFrame("Button", "BBBuffsNew", BBBuffsContent, "UIPanelButtonTemplate")
BBBuffsNew:SetHeight(30)
BBBuffsNew:SetWidth(80)
BBBuffsNew:SetText(NEW)
BBBuffsNew:ClearAllPoints()
BBBuffsNew:SetPoint("TOP", -140, y - 60)
BBBuffsNew:SetScript("OnClick", function(self) 
local tbl = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist
local counter = 1
if select(7, GetSpellInfo(BBBuffInput:GetText())) ~= nil then
if #tbl > 0 then
for idx = 1, #tbl do
counter = counter + 1
if GetSpellInfo(tbl[idx].spellid) == GetSpellInfo(BBBuffInput:GetText()) then
print("|cFFFF0000[Buff Buddy] "..L["ENTRY_ALREADY_EXISTS"].."|r")
return
end
end
end
table.insert(tbl, {spellid = select(7, GetSpellInfo(BBBuffInput:GetText())), index = counter})
print("|cFF00DFFF"..L["ENTRY_ADDED"].."|r")
else
print("|cFFFF0000[Buff Buddy] "..L["BAD_ENTRY_NAME"].."|r")
end
BBBuffInput:SetText("")
BuffBuddy_UpdateBuffPriority()
end)

BBBuffsUp = CreateFrame("Button", "BBBuffsUp", BBBuffsContent, "UIPanelButtonTemplate")
BBBuffsUp:SetHeight(30)
BBBuffsUp:SetWidth(80)
BBBuffsUp:SetText(L["UP"])
BBBuffsUp:ClearAllPoints()
BBBuffsUp:SetPoint("TOP", -60, y - 60)
BBBuffsUp:SetScript("OnClick", function(self)
local tbl, i = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist, 1
if #tbl == 0 then return end
for idx = 1, #tbl do
local button = _G["BBBuffPriorityListFrameContentButton"..idx]
if button.clicked == true then
i = idx
if (idx + 1) > #tbl then
return
else
tbl[idx].index = tbl[idx].index + 1
tbl[idx + 1].index = tbl[idx + 1].index - 1
table.sort(tbl, BuffBuddy_SortByIndex)
i = idx + 1
break
end
end
end
BuffBuddy_UpdateBuffPriority()
_G["BBBuffPriorityListFrameContentButton"..i]:Click()
end)

BBBuffsDown = CreateFrame("Button", "BBBuffsDown", BBBuffsContent, "UIPanelButtonTemplate")
BBBuffsDown:SetHeight(30)
BBBuffsDown:SetWidth(80)
BBBuffsDown:SetText(L["DOWN"])
BBBuffsDown:ClearAllPoints()
BBBuffsDown:SetPoint("TOP", 20, y - 60)
BBBuffsDown:SetScript("OnClick", function(self)
local tbl, i = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist, 1
if #tbl == 0 then return end
for idx = 1, #tbl do
local button = _G["BBBuffPriorityListFrameContentButton"..idx]
if button.clicked == true then
i = idx
if (idx - 1) == 0 then
return 
else
tbl[idx].index = tbl[idx].index - 1
tbl[idx - 1].index = tbl[idx - 1].index + 1
table.sort(tbl, BuffBuddy_SortByIndex)
i = idx - 1
break
end
end
end
BuffBuddy_UpdateBuffPriority()
_G["BBBuffPriorityListFrameContentButton"..i]:Click()
end)

BBBuffsDelete = CreateFrame("Button", "BBBuffsDelete", BBBuffsContent, "UIPanelButtonTemplate")
BBBuffsDelete:SetHeight(30)
BBBuffsDelete:SetWidth(80)
BBBuffsDelete:SetText(DELETE)
BBBuffsDelete:ClearAllPoints()
BBBuffsDelete:SetPoint("TOP", 100, y - 60)
BBBuffsDelete:SetScript("OnClick", function(self) 
local tbl = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist
local deleted =  false
for idx = 1, #tbl do
if _G["BBBuffPriorityListFrameContentButton"..idx].clicked == true then
i = idx
if i < #tbl then
for idx = (i + 1), #tbl do
tbl[idx].index = tbl[idx].index - 1
end
end
table.remove(tbl, idx)
deleted = true
break
end
end
BBBuffInput:SetText("")
if deleted == false then
print("|cFFFF0000[Buff Buddy] "..L["BAD_ENTRY_NAME"].."|r")
else
print("|cFF00DFFF"..L["ENTRY_DELETED"].."|r")
end
BBBuffInput:SetText("")
table.sort(tbl, BuffBuddy_SortByIndex)
BuffBuddy_UpdateBuffPriority()
end)

-------------------------------------------------------------------------
x = 50
y = 0
local spacey, scaley = 60, 45
y = y - 20 

y = y - scaley*10
BBBuffLeftToRight = CreateFrame("CheckButton", "BBBuffLeftToRight", BBBuffsContent, "ChatConfigCheckButtonTemplate")
BBBuffLeftToRight:SetPoint("TOPLEFT", 125, y)
BBBuffLeftToRightText:SetText(L["LEFT_TO_RIGHT"])
BBBuffLeftToRight:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.bufflefttoright)
-----------------------------------------------------------------------
BBBuffNewRowUp = CreateFrame("CheckButton", "BBBuffNewRowUp", BBBuffsContent, "ChatConfigCheckButtonTemplate")
BBBuffNewRowUp:SetPoint("TOP", 5, y)
BBBuffNewRowUpText:SetText(L["NEW_ROW_UP"])
BBBuffNewRowUp:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffnewrowup)
-----------------------------------------------------------------------
y = y - scaley*1.5
BBBuffPerRow = CreateFrame("Slider", "BBBuffPerRow", BBBuffsContent)
BBBuffPerRow:SetPoint("CENTER", BBBuffsContent, "TOP", 0, y)
BBBuffPerRow:SetWidth(300)
BBBuffPerRow:SetHeight(20)
BBBuffPerRow:SetOrientation("HORIZONTAL")
BBBuffPerRow:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBBuffPerRow:SetMinMaxValues(1, 20)
BBBuffPerRow:SetValue(8)
BBBuffPerRow:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBBuffPerRow:SetScript("OnValueChanged", function (self, value) BBBuffPerRowValue:SetText(BuffBuddy_Round(value)) end)
BBBuffPerRowHeader = BBBuffsContent:CreateFontString("BBBuffPerRowHeader", "OVERLAY", "GameFontNormal")
BBBuffPerRowHeader:SetPoint("BOTTOMLEFT", BBBuffPerRow, "TOPLEFT")
BBBuffPerRowHeader:SetText(L["BUFFS"].." "..L["PER_ROW"])
BBBuffPerRowValue = BBBuffsContent:CreateFontString("BBBuffPerRowValue", "OVERLAY", "GameFontNormal")
BBBuffPerRowValue:SetPoint("BOTTOMRIGHT", BBBuffPerRow, "TOPRIGHT")
BBBuffPerRowValue:SetText(BuffBuddy_Round(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffperrow))
-------------------------------------------------------------------------
y = y - scaley
BBBuffVerticalSpacing = CreateFrame("Slider", "BBBuffVerticalSpacing", BBBuffsContent)
BBBuffVerticalSpacing:SetPoint("CENTER", BBBuffsContent, "TOP", 0, y)
BBBuffVerticalSpacing:SetWidth(300)
BBBuffVerticalSpacing:SetHeight(20)
BBBuffVerticalSpacing:SetOrientation("HORIZONTAL")
BBBuffVerticalSpacing:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBBuffVerticalSpacing:SetMinMaxValues(1, 50)
BBBuffVerticalSpacing:SetValue(15)
BBBuffVerticalSpacing:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBBuffVerticalSpacing:SetScript("OnValueChanged", function (self, value) BBBuffVerticalSpacingValue:SetText(BuffBuddy_Round(value)) end)
BBBuffVerticalSpacingHeader = BBBuffsContent:CreateFontString("BBBuffVerticalSpacingHeader", "OVERLAY", "GameFontNormal")
BBBuffVerticalSpacingHeader:SetPoint("BOTTOMLEFT", BBBuffVerticalSpacing, "TOPLEFT")
BBBuffVerticalSpacingHeader:SetText(L["VERTICAL_SPACING"])
BBBuffVerticalSpacingValue = BBBuffsContent:CreateFontString("BBBuffVerticalSpacingValue", "OVERLAY", "GameFontNormal")
BBBuffVerticalSpacingValue:SetPoint("BOTTOMRIGHT", BBBuffVerticalSpacing, "TOPRIGHT")
BBBuffVerticalSpacingValue:SetText(BuffBuddy_Round(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffverticalspacing))
-------------------------------------------------------------------------
y = y - scaley
BBBuffHorizontalSpacing = CreateFrame("Slider", "BBBuffHorizontalSpacing", BBBuffsContent)
BBBuffHorizontalSpacing:SetPoint("CENTER", BBBuffsContent, "TOP", 0, y)
BBBuffHorizontalSpacing:SetWidth(300)
BBBuffHorizontalSpacing:SetHeight(20)
BBBuffHorizontalSpacing:SetOrientation("HORIZONTAL")
BBBuffHorizontalSpacing:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBBuffHorizontalSpacing:SetMinMaxValues(1, 50)
BBBuffHorizontalSpacing:SetValue(5)
BBBuffHorizontalSpacing:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBBuffHorizontalSpacing:SetScript("OnValueChanged", function (self, value) BBBuffHorizontalSpacingValue:SetText(BuffBuddy_Round(value)) end)
BBBuffHorizontalSpacingHeader = BBBuffsContent:CreateFontString("BBBuffHorizontalSpacingHeader", "OVERLAY", "GameFontNormal")
BBBuffHorizontalSpacingHeader:SetPoint("BOTTOMLEFT", BBBuffHorizontalSpacing, "TOPLEFT")
BBBuffHorizontalSpacingHeader:SetText(L["HORIZONTAL_SPACING"])
BBBuffHorizontalSpacingValue = BBBuffsContent:CreateFontString("BBBuffHorizontalSpacingValue", "OVERLAY", "GameFontNormal")
BBBuffHorizontalSpacingValue:SetPoint("BOTTOMRIGHT", BBBuffHorizontalSpacing, "TOPRIGHT")
BBBuffHorizontalSpacingValue:SetText(BuffBuddy_Round(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffhorizontalspacing))
-------------------------------------------------------------------------
y = y - scaley
BBBuffFrameScale = CreateFrame("Slider", "BBBuffFrameScale", BBBuffsContent)
BBBuffFrameScale:SetPoint("CENTER", BBBuffsContent, "TOP", 0, y)
BBBuffFrameScale:SetWidth(300)
BBBuffFrameScale:SetHeight(20)
BBBuffFrameScale:SetOrientation("HORIZONTAL")
BBBuffFrameScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBBuffFrameScale:SetMinMaxValues(0.5, 10)
BBBuffFrameScale:SetValue(1)
BBBuffFrameScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBBuffFrameScale:SetScript("OnValueChanged", function (self, value) BBBuffFrameScaleValue:SetText(string.sub(value, 1, 4)) BBBuffFrame:SetScale(value) end)
BBBuffFrameScaleHeader = BBBuffsContent:CreateFontString("BBBuffFrameScaleHeader", "OVERLAY", "GameFontNormal")
BBBuffFrameScaleHeader:SetPoint("BOTTOMLEFT", BBBuffFrameScale, "TOPLEFT")
BBBuffFrameScaleHeader:SetText(L["BUFF_FRAME"].." "..L["SCALE"])
BBBuffFrameScaleValue = BBBuffsContent:CreateFontString("BBBuffFrameScaleValue", "OVERLAY", "GameFontNormal")
BBBuffFrameScaleValue:SetPoint("BOTTOMRIGHT", BBBuffFrameScale, "TOPRIGHT")
BBBuffFrameScaleValue:SetText(string.sub(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbbuffframe, 1, 4))
-------------------------------------------------------------------------

BBBuffsScroll:SetMinMaxValues(0, (abs(y)/60)*40 + 200)
BBBuffsScroll:SetValue(0)
BuffBuddy.buffs:Hide()
-------------------------------------------------------------------------
end

function BuffBuddy_CreateDebuffsOptionsMenu()
-- Buffs Options --------------------------------------------------
BuffBuddy.debuffs = CreateFrame("Frame", "BBDebuffsOptions", BBOptionsFrame)
BuffBuddy.debuffs:SetWidth(625)
BuffBuddy.debuffs:SetHeight(570)
BuffBuddy.debuffs:SetPoint("LEFT", BBOptionsFrameButtons, "RIGHT", 5, 0)
BuffBuddy.debuffs.name = L["DEBUFFS"]

BBDebuffsScrollFrame = CreateFrame("ScrollFrame", "BBDebuffsScrollFrame", BuffBuddy.debuffs)
BBDebuffsScrollFrame:SetPoint("TOPLEFT", 10, -10) 
BBDebuffsScrollFrame:SetPoint("BOTTOMRIGHT", -15, 15) 

BBDebuffsContent = CreateFrame("Frame", "BBDebuffsContent", BBDebuffsScrollFrame)
BBDebuffsContent:SetPoint("CENTER")
BBDebuffsContent:SetWidth(580)
BBDebuffsContent:SetHeight(2000)
BBDebuffsScrollFrame:SetScrollChild(BBDebuffsContent)

BBDebuffsScroll = CreateFrame("Slider", "BBDebuffsScroll", BBDebuffsScrollFrame, "UIPanelScrollBarTemplate")
BBDebuffsScroll:CreateTexture("$parentBG")
BBDebuffsScrollBG:SetWidth(16)
BBDebuffsScrollBG:SetHeight(445)
BBDebuffsScrollBG:SetPoint("CENTER", -0.5, 0)
BBDebuffsScrollBG:SetTexture(0.2, 0.2, 0.2, 0.5)
BBDebuffsScroll:SetOrientation("VERTICAL")
BBDebuffsScroll:SetWidth(20)
BBDebuffsScroll:SetHeight(450)
BBDebuffsScroll:SetPoint("RIGHT", BuffBuddy.debuffs, "RIGHT", -5, 0)
BBDebuffsScroll:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
BBDebuffsScroll:SetValueStep(20)
BBDebuffsScroll:SetValue(0)
BBDebuffsContent:SetScript("OnMouseWheel", function(self, delta)
local scroll = BBDebuffsScroll:GetValue()
if delta > 0  then
BBDebuffsScroll:SetValue(scroll - BBDebuffsScroll:GetValueStep())
elseif delta < 0 then
BBDebuffsScroll:SetValue(scroll + BBDebuffsScroll:GetValueStep())
end
end)
-------------------------------------------------------------------------
-------------------------------------------------------------------------
local x, y, xoff, yoff = 0, 0, 15, -20
CreateFrame("Frame", "BBDebuffPriorityListFrame", BBDebuffsContent)
BBDebuffPriorityListFrame:SetPoint("TOP", -20, -50)
BBDebuffPriorityListFrame:SetWidth(200)
BBDebuffPriorityListFrame:SetHeight(300)
BBDebuffPriorityListFrame:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12})

BBDebuffPriorityListFrame:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
BBDebuffPriorityListFrameText:SetPoint("BOTTOM", BBDebuffPriorityListFrame, "TOP", 0, 10)
BBDebuffPriorityListFrameText:SetTextHeight(20)
BBDebuffPriorityListFrameText:SetText(L["DEBUFF_PRIORITY_LIST"])


BBDebuffPriorityListFrameScrollFrame = CreateFrame("ScrollFrame", "BBDebuffPriorityListFrameScrollFrame", BBDebuffPriorityListFrame)
BBDebuffPriorityListFrameScrollFrame:SetPoint("TOPLEFT", 10, -10) 
BBDebuffPriorityListFrameScrollFrame:SetPoint("BOTTOMRIGHT", -30, 40) 

BBDebuffPriorityListFrameContent = CreateFrame("Frame", "BBDebuffPriorityListFrameContent", BBDebuffPriorityListFrameScrollFrame)
BBDebuffPriorityListFrameContent:SetPoint("CENTER")
BBDebuffPriorityListFrameContent:SetWidth(160)
BBDebuffPriorityListFrameContent:SetHeight(#BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist * 20 + 300)
BBDebuffPriorityListFrameScrollFrame:SetScrollChild(BBDebuffPriorityListFrameContent)

BBDebuffPriorityListFrameScroll = CreateFrame("Slider", "BBDebuffPriorityListFrameScroll", BBDebuffPriorityListFrameScrollFrame, "UIPanelScrollBarTemplate")
BBDebuffPriorityListFrameScroll:CreateTexture("$parentBG")
BBDebuffPriorityListFrameScrollBG:SetWidth(16)
BBDebuffPriorityListFrameScrollBG:SetHeight(245)
BBDebuffPriorityListFrameScrollBG:SetPoint("CENTER", -0.5, 0)
BBDebuffPriorityListFrameScrollBG:SetTexture(0.2, 0.2, 0.2, 0.5)
BBDebuffPriorityListFrameScroll:SetOrientation("VERTICAL")
BBDebuffPriorityListFrameScroll:SetWidth(20)
BBDebuffPriorityListFrameScroll:SetHeight(250)
BBDebuffPriorityListFrameScroll:SetPoint("RIGHT", BBDebuffPriorityListFrame, "RIGHT", -5, 0)
BBDebuffPriorityListFrameScroll:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
BBDebuffPriorityListFrameScroll:SetValueStep(20)
BBDebuffPriorityListFrameScroll:SetValue(0)
BBDebuffPriorityListFrameContent:SetScript("OnMouseWheel", function(self, delta)
local scroll = BBDebuffPriorityListFrameScroll:GetValue()
if delta > 0  then
BBDebuffPriorityListFrameScroll:SetValue(scroll - BBDebuffPriorityListFrameScroll:GetValueStep())
elseif delta < 0 then
BBDebuffPriorityListFrameScroll:SetValue(scroll + BBDebuffPriorityListFrameScroll:GetValueStep())
end
end)
BBDebuffPriorityListFrameScroll:SetMinMaxValues(0, (#BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist * 20))
BBDebuffPriorityListFrameScroll:SetValue(0)
----------------------------------------------------------------------------------
y = y + yoff * 2 - 270
BBDebuffInput = CreateFrame("EditBox", "BBDebuffInput", BBDebuffsContent, "InputBoxTemplate")
BBDebuffInput:SetPoint("TOP", -20, y - 60)
BBDebuffInput:SetWidth(200)
BBDebuffInput:SetHeight(20)
BBDebuffInput:SetAutoFocus(false)
BBDebuffInput:SetScript("OnEnterPressed", function(self)
BBDebuffsNew:Click()
end)
-----------------------------------------------------------------------
-----------------------------------------------------------------------
y = y + yoff * 2 + 10

BBDebuffsNew = CreateFrame("Button", "BBDebuffsNew", BBDebuffsContent, "UIPanelButtonTemplate")
BBDebuffsNew:SetHeight(30)
BBDebuffsNew:SetWidth(80)
BBDebuffsNew:SetText(NEW)
BBDebuffsNew:ClearAllPoints()
BBDebuffsNew:SetPoint("TOP", -140, y - 60)
BBDebuffsNew:SetScript("OnClick", function(self) 
local tbl = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist
local counter = 1
if select(7, GetSpellInfo(BBDebuffInput:GetText())) ~= nil then
if #tbl > 0 then
for idx = 1, #tbl do
counter = counter + 1
if GetSpellInfo(tbl[idx].spellid) == GetSpellInfo(BBDebuffInput:GetText()) then
print("|cFFFF0000[Buff Buddy] "..L["ENTRY_ALREADY_EXISTS"].."|r")
return
end
end
end
table.insert(tbl, {spellid = select(7, GetSpellInfo(BBDebuffInput:GetText())), index = counter})
print("|cFF00DFFF"..L["ENTRY_ADDED"].."|r")
else
print("|cFFFF0000[Buff Buddy] "..L["BAD_ENTRY_NAME"].."|r")
end
BBDebuffInput:SetText("")
BuffBuddy_UpdateDebuffPriority()
end)

BBDebuffsUp = CreateFrame("Button", "BBDebuffsUp", BBDebuffsContent, "UIPanelButtonTemplate")
BBDebuffsUp:SetHeight(30)
BBDebuffsUp:SetWidth(80)
BBDebuffsUp:SetText(L["UP"])
BBDebuffsUp:ClearAllPoints()
BBDebuffsUp:SetPoint("TOP", -60, y - 60)
BBDebuffsUp:SetScript("OnClick", function(self)
local tbl, i = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist, 1
if #tbl == 0 then return end
for idx = 1, #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist do
local button = _G["BBDebuffPriorityListFrameContentButton"..idx]
if button.clicked == true then
i = idx
if (idx + 1) > #tbl then
return
else
tbl[idx].index = tbl[idx].index + 1
tbl[idx + 1].index = tbl[idx + 1].index - 1
table.sort(tbl, BuffBuddy_SortByIndex)
i = idx + 1
break
end
end
end
BuffBuddy_UpdateDebuffPriority()
_G["BBDebuffPriorityListFrameContentButton"..i]:Click()
end)

BBDebuffsDown = CreateFrame("Button", "BBDebuffsDown", BBDebuffsContent, "UIPanelButtonTemplate")
BBDebuffsDown:SetHeight(30)
BBDebuffsDown:SetWidth(80)
BBDebuffsDown:SetText(L["DOWN"])
BBDebuffsDown:ClearAllPoints()
BBDebuffsDown:SetPoint("TOP", 20, y - 60)
BBDebuffsDown:SetScript("OnClick", function(self)
local tbl, i = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist, 1
if #tbl == 0 then return end
for idx = 1, #BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist do
local button = _G["BBDebuffPriorityListFrameContentButton"..idx]
if button.clicked == true then
i = idx
if (idx - 1) == 0 then
return 
else
tbl[idx].index = tbl[idx].index - 1
tbl[idx - 1].index = tbl[idx - 1].index + 1
table.sort(tbl, BuffBuddy_SortByIndex)
i = idx - 1
break
end
end
end
BuffBuddy_UpdateDebuffPriority()
_G["BBDebuffPriorityListFrameContentButton"..i]:Click()
end)

BBDebuffsDelete = CreateFrame("Button", "BBDebuffsDelete", BBDebuffsContent, "UIPanelButtonTemplate")
BBDebuffsDelete:SetHeight(30)
BBDebuffsDelete:SetWidth(80)
BBDebuffsDelete:SetText(DELETE)
BBDebuffsDelete:ClearAllPoints()
BBDebuffsDelete:SetPoint("TOP", 100, y - 60)
BBDebuffsDelete:SetScript("OnClick", function(self) 
local tbl = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist
local deleted = false
for idx = 1, #tbl do
if _G["BBDebuffPriorityListFrameContentButton"..idx].clicked == true then
i = idx
if i < #tbl then
for idx = (i + 1), #tbl do
tbl[idx].index = tbl[idx].index - 1
end
end
table.remove(tbl, idx)
deleted = true
break
end
end
BBDebuffInput:SetText("")
if deleted == false then
print("|cFFFF0000[Buff Buddy] "..L["BAD_ENTRY_NAME"].."|r")
else
print("|cFF00DFFF"..L["ENTRY_DELETED"].."|r")
end
BBDebuffInput:SetText("")
table.sort(tbl, BuffBuddy_SortByIndex)
BuffBuddy_UpdateDebuffPriority()
end)

-------------------------------------------------------------------------
x = 50
y = 0
local spacey, scaley = 60, 45
y = y - 20 

y = y - scaley*10
BBDebuffLeftToRight = CreateFrame("CheckButton", "BBDebuffLeftToRight", BBDebuffsContent, "ChatConfigCheckButtonTemplate")
BBDebuffLeftToRight:SetPoint("TOPLEFT", 125, y)
BBDebuffLeftToRightText:SetText(L["LEFT_TO_RIGHT"])
BBDebuffLeftToRight:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debufflefttoright)
-----------------------------------------------------------------------
BBDebuffNewRowUp = CreateFrame("CheckButton", "BBDebuffNewRowUp", BBDebuffsContent, "ChatConfigCheckButtonTemplate")
BBDebuffNewRowUp:SetPoint("TOP", 5, y)
BBDebuffNewRowUpText:SetText(L["NEW_ROW_UP"])
BBDebuffNewRowUp:SetChecked(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffnewrowup)
-----------------------------------------------------------------------
y = y - scaley*1.5
BBDebuffPerRow = CreateFrame("Slider", "BBDebuffPerRow", BBDebuffsContent)
BBDebuffPerRow:SetPoint("CENTER", BBDebuffsContent, "TOP", 0, y)
BBDebuffPerRow:SetWidth(300)
BBDebuffPerRow:SetHeight(20)
BBDebuffPerRow:SetOrientation("HORIZONTAL")
BBDebuffPerRow:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBDebuffPerRow:SetMinMaxValues(1, 20)
BBDebuffPerRow:SetValue(8)
BBDebuffPerRow:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBDebuffPerRow:SetScript("OnValueChanged", function (self, value) BBDebuffPerRowValue:SetText(BuffBuddy_Round(value)) end)
BBDebuffPerRowHeader = BBDebuffsContent:CreateFontString("BBDebuffPerRowHeader", "OVERLAY", "GameFontNormal")
BBDebuffPerRowHeader:SetPoint("BOTTOMLEFT", BBDebuffPerRow, "TOPLEFT")
BBDebuffPerRowHeader:SetText(L["DEBUFFS"].." "..L["PER_ROW"])
BBDebuffPerRowValue = BBDebuffsContent:CreateFontString("BBDebuffPerRowValue", "OVERLAY", "GameFontNormal")
BBDebuffPerRowValue:SetPoint("BOTTOMRIGHT", BBDebuffPerRow, "TOPRIGHT")
BBDebuffPerRowValue:SetText(BuffBuddy_Round(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffperrow))
-------------------------------------------------------------------------
y = y - scaley
BBDebuffVerticalSpacing = CreateFrame("Slider", "BBDebuffVerticalSpacing", BBDebuffsContent)
BBDebuffVerticalSpacing:SetPoint("CENTER", BBDebuffsContent, "TOP", 0, y)
BBDebuffVerticalSpacing:SetWidth(300)
BBDebuffVerticalSpacing:SetHeight(20)
BBDebuffVerticalSpacing:SetOrientation("HORIZONTAL")
BBDebuffVerticalSpacing:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBDebuffVerticalSpacing:SetMinMaxValues(1, 50)
BBDebuffVerticalSpacing:SetValue(15)
BBDebuffVerticalSpacing:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBDebuffVerticalSpacing:SetScript("OnValueChanged", function (self, value) BBDebuffVerticalSpacingValue:SetText(BuffBuddy_Round(value)) end)
BBDebuffVerticalSpacingHeader = BBDebuffsContent:CreateFontString("BBDebuffVerticalSpacingHeader", "OVERLAY", "GameFontNormal")
BBDebuffVerticalSpacingHeader:SetPoint("BOTTOMLEFT", BBDebuffVerticalSpacing, "TOPLEFT")
BBDebuffVerticalSpacingHeader:SetText(L["VERTICAL_SPACING"])
BBDebuffVerticalSpacingValue = BBDebuffsContent:CreateFontString("BBDebuffVerticalSpacingValue", "OVERLAY", "GameFontNormal")
BBDebuffVerticalSpacingValue:SetPoint("BOTTOMRIGHT", BBDebuffVerticalSpacing, "TOPRIGHT")
BBDebuffVerticalSpacingValue:SetText(BuffBuddy_Round(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffverticalspacing))
-------------------------------------------------------------------------
y = y - scaley
BBDebuffHorizontalSpacing = CreateFrame("Slider", "BBDebuffHorizontalSpacing", BBDebuffsContent)
BBDebuffHorizontalSpacing:SetPoint("CENTER", BBDebuffsContent, "TOP", 0, y)
BBDebuffHorizontalSpacing:SetWidth(300)
BBDebuffHorizontalSpacing:SetHeight(20)
BBDebuffHorizontalSpacing:SetOrientation("HORIZONTAL")
BBDebuffHorizontalSpacing:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBDebuffHorizontalSpacing:SetMinMaxValues(1, 50)
BBDebuffHorizontalSpacing:SetValue(5)
BBDebuffHorizontalSpacing:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBDebuffHorizontalSpacing:SetScript("OnValueChanged", function (self, value) BBDebuffHorizontalSpacingValue:SetText(BuffBuddy_Round(value)) end)
BBDebuffHorizontalSpacingHeader = BBDebuffsContent:CreateFontString("BBDebuffHorizontalSpacingHeader", "OVERLAY", "GameFontNormal")
BBDebuffHorizontalSpacingHeader:SetPoint("BOTTOMLEFT", BBDebuffHorizontalSpacing, "TOPLEFT")
BBDebuffHorizontalSpacingHeader:SetText(L["HORIZONTAL_SPACING"])
BBDebuffHorizontalSpacingValue = BBDebuffsContent:CreateFontString("BBDebuffHorizontalSpacingValue", "OVERLAY", "GameFontNormal")
BBDebuffHorizontalSpacingValue:SetPoint("BOTTOMRIGHT", BBDebuffHorizontalSpacing, "TOPRIGHT")
BBDebuffHorizontalSpacingValue:SetText(BuffBuddy_Round(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffhorizontalspacing))
-------------------------------------------------------------------------
y = y - scaley
BBDebuffFrameScale = CreateFrame("Slider", "BBDebuffFrameScale", BBDebuffsContent)
BBDebuffFrameScale:SetPoint("CENTER", BBDebuffsContent, "TOP", 0, y)
BBDebuffFrameScale:SetWidth(300)
BBDebuffFrameScale:SetHeight(20)
BBDebuffFrameScale:SetOrientation("HORIZONTAL")
BBDebuffFrameScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
BBDebuffFrameScale:SetMinMaxValues(0.5, 10)
BBDebuffFrameScale:SetValue(1)
BBDebuffFrameScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
BBDebuffFrameScale:SetScript("OnValueChanged", function (self, value) BBDebuffFrameScaleValue:SetText(string.sub(value, 1, 4)) BBDebuffFrame:SetScale(value) end)
BBDebuffFrameScaleHeader = BBDebuffsContent:CreateFontString("BBDebuffFrameScaleHeader", "OVERLAY", "GameFontNormal")
BBDebuffFrameScaleHeader:SetPoint("BOTTOMLEFT", BBDebuffFrameScale, "TOPLEFT")
BBDebuffFrameScaleHeader:SetText(L["DEBUFF_FRAME"].." "..L["SCALE"])
BBDebuffFrameScaleValue = BBDebuffsContent:CreateFontString("BBDebuffFrameScaleValue", "OVERLAY", "GameFontNormal")
BBDebuffFrameScaleValue:SetPoint("BOTTOMRIGHT", BBDebuffFrameScale, "TOPRIGHT")
BBDebuffFrameScaleValue:SetText(string.sub(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.scale.bbdebuffframe, 1, 4))
-------------------------------------------------------------------------

BBDebuffsScroll:SetMinMaxValues(0, (abs(y)/60)*40 + 200)
BBDebuffsScroll:SetValue(0)
BuffBuddy.debuffs:Hide()
-------------------------------------------------------------------------
end




